"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MultiInputField = exports.multiInputFieldGap = exports.multiInputFieldPadding = exports.multiInputFieldType = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const icons_1 = require("@pikas-ui/icons");
const styles_1 = require("@pikas-ui/styles");
const react_1 = require("react");
const LabelPrimitive = __importStar(require("@radix-ui/react-label"));
const text_1 = require("@pikas-ui/text");
const tooltip_1 = require("@pikas-ui/tooltip");
const color_1 = require("@pikas-utils/color");
const index_js_1 = require("./badge/index.js");
const hooks_1 = require("@pikas-utils/hooks");
const Container = (0, styles_1.styled)('div', {
    display: 'flex',
    flexDirection: 'column',
    userSelect: 'none',
});
const InputContainer = (0, styles_1.styled)('div', {
    width: '100%',
    overflow: 'hidden',
    display: 'flex',
    alignItems: 'center',
    justifyContent: 'center',
    borderStyle: 'solid',
    variants: {
        focus: {
            true: {
                outline: 'solid',
                outlineColor: '$PRIMARY',
                outlineWidth: 2,
            },
        },
        gap: {
            xs: {
                customColumnGap: 2,
            },
            sm: {
                customColumnGap: 4,
            },
            md: {
                customColumnGap: 8,
            },
            lg: {
                customColumnGap: 16,
            },
            xl: {
                customColumnGap: 32,
            },
        },
    },
});
const InputContent = (0, styles_1.styled)('div', {
    display: 'flex',
    alignItems: 'center',
    flexWrap: 'wrap',
    width: '100%',
    variants: {
        padding: {
            xs: {
                padding: '4px 8px',
            },
            sm: {
                padding: '6px 12px',
            },
            md: {
                padding: '8px 16px',
            },
            lg: {
                padding: '12px 24px',
            },
            xl: {
                padding: '16px 32px',
            },
        },
        gap: {
            xs: {
                customGap: 2,
            },
            sm: {
                customGap: 4,
            },
            md: {
                customGap: 8,
            },
            lg: {
                customGap: 16,
            },
            xl: {
                customGap: 32,
            },
        },
    },
});
const Input = (0, styles_1.styled)('input', {
    width: 'initial',
    minWidth: 120,
    outline: 'none',
    fontSize: '$EM-SMALL',
    border: 'none',
    fontFamily: '$roboto',
    backgroundColor: '$TRANSPARENT',
    flex: 1,
});
const LeftContainer = (0, styles_1.styled)(LabelPrimitive.Root, {
    display: 'flex',
    alignItems: 'center',
    justifyContent: 'center',
    variants: {
        padding: {
            xs: {
                padding: 2,
            },
            sm: {
                padding: 4,
            },
            md: {
                padding: 8,
            },
            lg: {
                padding: 16,
            },
            xl: {
                padding: 32,
            },
        },
    },
});
const RightContainer = (0, styles_1.styled)(LabelPrimitive.Root, {
    display: 'flex',
    alignItems: 'center',
    justifyContent: 'center',
    variants: {
        padding: {
            xs: {
                padding: 2,
            },
            sm: {
                padding: 4,
            },
            md: {
                padding: 8,
            },
            lg: {
                padding: 16,
            },
            xl: {
                padding: 32,
            },
        },
    },
});
const LabelContainer = (0, styles_1.styled)('div', {
    display: 'flex',
    marginBottom: 4,
});
const Required = (0, styles_1.styled)('div', {
    color: '$WARNING',
    marginLeft: 4,
});
exports.multiInputFieldType = {
    color: true,
    date: true,
    'datetime-local': true,
    email: true,
    hidden: true,
    month: true,
    number: true,
    password: true,
    search: true,
    tel: true,
    text: true,
    time: true,
    url: true,
    week: true,
};
exports.multiInputFieldPadding = {
    xs: true,
    sm: true,
    md: true,
    lg: true,
    xl: true,
};
exports.multiInputFieldGap = {
    xs: true,
    sm: true,
    md: true,
    lg: true,
    xl: true,
};
const getColor = ({ colorName, colorHex, backgroundColorName, }) => {
    const theme = (0, styles_1.useTheme)();
    if (colorHex) {
        return colorHex;
    }
    else if (colorName) {
        return `$${colorName}`;
    }
    else if (theme) {
        return new color_1.Color(theme.colors[backgroundColorName !== null && backgroundColorName !== void 0 ? backgroundColorName : 'WHITE'].value).getContrast();
    }
    else {
        return '';
    }
};
exports.MultiInputField = (0, react_1.forwardRef)((_a, ref) => {
    var _b, _c;
    var { id, type = 'text', onChange, boxShadow = 'DIMINUTION_1', borderRadius = 'md', padding = 'md', fontSize = 'EM-MEDIUM', textError, label, css, borderColorName = 'TRANSPARENT', borderWidth = 0, autoComplete, min, max, LeftIcon, RightIcon, leftChildren, rightChildren, backgroundColorName = 'GRAY_LIGHTEST_1', outline = true, description, gap = 'sm', width = '100%', maxWidth = '100%', minWidth, backgroundColorHex, borderColorHex, colorName, colorHex, placeholderColorName = 'BLACK_LIGHT', placeholderColorHex, leftIconColorName, leftIconColorHex, rightIconColorName, rightIconColorHex, leftIconSize, rightIconSize, required, info, disabled = false, data, defaultValues = [] } = _a, props = __rest(_a, ["id", "type", "onChange", "boxShadow", "borderRadius", "padding", "fontSize", "textError", "label", "css", "borderColorName", "borderWidth", "autoComplete", "min", "max", "LeftIcon", "RightIcon", "leftChildren", "rightChildren", "backgroundColorName", "outline", "description", "gap", "width", "maxWidth", "minWidth", "backgroundColorHex", "borderColorHex", "colorName", "colorHex", "placeholderColorName", "placeholderColorHex", "leftIconColorName", "leftIconColorHex", "rightIconColorName", "rightIconColorHex", "leftIconSize", "rightIconSize", "required", "info", "disabled", "data", "defaultValues"]);
    const refInput = (0, react_1.useRef)(null);
    const multiRef = (0, hooks_1.useMergedRef)(ref, refInput);
    const [focus, setFocus] = (0, react_1.useState)(false);
    const [currentValues, setCurrentValues] = (0, react_1.useState)(defaultValues);
    const handleDeleteValue = (index) => {
        setCurrentValues((currentState) => {
            const copy = [...currentState];
            copy.splice(index, 1);
            return copy;
        });
    };
    const handleRemoveLastValue = () => {
        setCurrentValues((currentState) => {
            const copy = [...currentState];
            copy.pop();
            return copy;
        });
    };
    const handleKeyUp = (e) => {
        const inputValue = e.currentTarget.value;
        if (type === 'number' && refInput.current) {
            const value = parseInt(inputValue);
            if (max !== undefined && value > max) {
                refInput.current.value = `${max}`;
            }
            else if (min !== undefined && value < min) {
                refInput.current.value = `${min}`;
            }
        }
        if (e.key === 'Enter' && !!e.currentTarget.value) {
            setCurrentValues((currentState) => [...currentState, inputValue]);
            e.currentTarget.value = '';
        }
    };
    const handleKeyDown = (e) => {
        if (e.key === 'Backspace' &&
            !e.currentTarget.value &&
            currentValues.length) {
            e.preventDefault();
            e.currentTarget.value = currentValues[currentValues.length - 1];
            handleRemoveLastValue();
        }
    };
    (0, react_1.useEffect)(() => {
        onChange === null || onChange === void 0 ? void 0 : onChange(currentValues);
    }, [currentValues]);
    return ((0, jsx_runtime_1.jsxs)(Container, Object.assign({ css: Object.assign({ fontSize: `$${fontSize}`, width,
            maxWidth,
            minWidth, opacity: disabled ? 0.5 : 1, cursor: disabled ? 'not-allowed' : undefined, '& > *': {
                pointerEvents: disabled ? 'none' : undefined,
            } }, css === null || css === void 0 ? void 0 : css.container) }, { children: [label ? ((0, jsx_runtime_1.jsxs)(LabelContainer, { children: [(0, jsx_runtime_1.jsx)(text_1.Label, Object.assign({ htmlFor: id, css: css === null || css === void 0 ? void 0 : css.label }, { children: label })), required ? (0, jsx_runtime_1.jsx)(Required, Object.assign({ css: css === null || css === void 0 ? void 0 : css.required }, { children: "*" })) : null, info ? ((0, jsx_runtime_1.jsx)(tooltip_1.Tooltip, Object.assign({ content: info, css: css === null || css === void 0 ? void 0 : css.infoTooltip }, { children: (0, jsx_runtime_1.jsx)(icons_1.IconByName, { name: "bx:info-circle", colorName: "BLACK_LIGHT", css: {
                                container: Object.assign({ marginLeft: 4 }, (_b = css === null || css === void 0 ? void 0 : css.infoIcon) === null || _b === void 0 ? void 0 : _b.container),
                                svg: Object.assign({}, (_c = css === null || css === void 0 ? void 0 : css.infoIcon) === null || _c === void 0 ? void 0 : _c.svg),
                            } }) }))) : null] })) : null, description ? ((0, jsx_runtime_1.jsx)(text_1.Description, Object.assign({ css: Object.assign({ marginBottom: 4 }, css === null || css === void 0 ? void 0 : css.description) }, { children: description }))) : null, (0, jsx_runtime_1.jsxs)(InputContainer, Object.assign({ focus: outline ? focus : undefined, gap: gap, onBlur: () => setFocus(false), css: Object.assign({ br: borderRadius, borderColor: borderColorHex !== null && borderColorHex !== void 0 ? borderColorHex : `$${borderColorName}`, backgroundColor: backgroundColorHex !== null && backgroundColorHex !== void 0 ? backgroundColorHex : `$${backgroundColorName}`, boxShadow: `$${boxShadow}`, borderWidth }, css === null || css === void 0 ? void 0 : css.inputContainer) }, { children: [leftChildren && ((0, jsx_runtime_1.jsx)(LeftContainer, Object.assign({ htmlFor: id, padding: padding, css: Object.assign(Object.assign({}, (id && {
                            cursor: 'pointer',
                        })), css === null || css === void 0 ? void 0 : css.left) }, { children: leftChildren }))), LeftIcon && ((0, jsx_runtime_1.jsx)(LeftContainer, Object.assign({ htmlFor: id, padding: padding, css: Object.assign(Object.assign({}, (id && {
                            cursor: 'pointer',
                        })), css === null || css === void 0 ? void 0 : css.left) }, { children: (0, jsx_runtime_1.jsx)(LeftIcon, { size: leftIconSize !== null && leftIconSize !== void 0 ? leftIconSize : '1em', colorHex: getColor({
                                colorName: leftIconColorName !== null && leftIconColorName !== void 0 ? leftIconColorName : colorName,
                                colorHex: leftIconColorHex !== null && leftIconColorHex !== void 0 ? leftIconColorHex : colorHex,
                                backgroundColorName,
                            }), css: css === null || css === void 0 ? void 0 : css.leftIcon }) }))), (0, jsx_runtime_1.jsxs)(InputContent, Object.assign({ padding: padding, gap: gap, css: css === null || css === void 0 ? void 0 : css.inputContent }, { children: [currentValues.map((item, index) => ((0, jsx_runtime_1.jsx)(index_js_1.MultiInputFieldBadge, { index: index, value: item, onDelete: handleDeleteValue, css: css === null || css === void 0 ? void 0 : css.badge }, index))), (0, jsx_runtime_1.jsx)(Input, Object.assign({ ref: multiRef, id: id, type: type, onKeyUp: handleKeyUp, onKeyDown: handleKeyDown, autoComplete: autoComplete, min: min, max: max, onFocus: () => setFocus(true), disabled: disabled, required: required, css: Object.assign({ color: getColor({ colorName, colorHex, backgroundColorName }), '&::placeholder': {
                                        color: getColor({
                                            colorName: placeholderColorName,
                                            colorHex: placeholderColorHex,
                                            backgroundColorName,
                                        }),
                                    } }, css === null || css === void 0 ? void 0 : css.input) }, props, data))] })), RightIcon && ((0, jsx_runtime_1.jsx)(RightContainer, Object.assign({ htmlFor: id, padding: padding, css: Object.assign(Object.assign({}, (id && {
                            cursor: 'pointer',
                        })), css === null || css === void 0 ? void 0 : css.right) }, { children: (0, jsx_runtime_1.jsx)(RightIcon, { size: rightIconSize !== null && rightIconSize !== void 0 ? rightIconSize : '1em', colorHex: getColor({
                                colorName: rightIconColorName !== null && rightIconColorName !== void 0 ? rightIconColorName : colorName,
                                colorHex: rightIconColorHex !== null && rightIconColorHex !== void 0 ? rightIconColorHex : colorHex,
                                backgroundColorName,
                            }), css: css === null || css === void 0 ? void 0 : css.rightIcon }) }))), rightChildren && ((0, jsx_runtime_1.jsx)(RightContainer, Object.assign({ htmlFor: id, padding: padding, css: Object.assign(Object.assign({}, (id && {
                            cursor: 'pointer',
                        })), css === null || css === void 0 ? void 0 : css.right) }, { children: rightChildren })))] })), textError && ((0, jsx_runtime_1.jsx)(text_1.TextError, Object.assign({ css: Object.assign({ marginTop: 5 }, css === null || css === void 0 ? void 0 : css.textError) }, { children: textError })))] })));
});
exports.MultiInputField.displayName = 'MultiInputField';
